Attribute VB_Name = "modBackgroundThread"
Option Explicit

Public Const ThumbnailSize          As Long = 128

Public Enum UserMessages
    SET_LABEL_CAPTION = WM_APP
    SET_PROGRESS
    ADD_TO_LIST
End Enum

Public Type UserData
    NotifyWnd                   As Long
    FindPath                    As Long
    Stream                      As IStream
    Progress                    As Single
End Type
Public Type ThreadData
    NotifyWnd                   As Long
    FindPath                    As String
    Stream                      As IStream
    Progress                    As Single
End Type

Public Function BackgroundThread( _
                ByRef param As ThreadData) As Long
    Dim fso         As FileSystemObject
    Dim curFolder   As Folder
    Dim curFile     As File
    Dim gdipToken   As Long
    Dim gdipStartup As GdiplusStartupInput
    Dim image       As Long
    Dim thumb       As Long
    Dim rc          As RECTL
    Dim bd          As BitmapData
    Dim fileIndex   As Long
    Dim pointer     As Long
    Dim inIDE       As Boolean
    
    Debug.Assert MakeTrue(inIDE)
    
    gdipStartup.GdiplusVersion = 1

    GdiplusStartup gdipToken, gdipStartup

    Set fso = New FileSystemObject
    Set curFolder = fso.GetFolder(param.FindPath)

    rc.Right = ThumbnailSize
    rc.Bottom = ThumbnailSize

    For Each curFile In curFolder.Files
        ' // Set label caption
        PostMessage param.NotifyWnd, SET_LABEL_CAPTION, Len(curFile.Name), ByVal SysAllocString(ByVal StrPtr(curFile.Name))
        ' // Open image
        If GdipLoadImageFromFile(StrPtr(curFile.Path), image) = 0 Then

            If GdipGetImageThumbnail(image, ThumbnailSize, ThumbnailSize, thumb) = 0 Then

                If GdipBitmapLockBits(thumb, rc, ImageLockModeRead, PixelFormat32bppARGB, bd) = 0 Then
                    
                    pointer = param.Stream.Seek(0, STREAM_SEEK_CUR) * 10000
                    
                    param.Stream.Write ByVal bd.scan0, bd.stride * bd.Height
                    
                    param.Progress = fileIndex / curFolder.Files.count
                    
                    PostMessage param.NotifyWnd, SET_PROGRESS, param.Progress * 100, ByVal 0&
                    PostMessage param.NotifyWnd, ADD_TO_LIST, pointer, ByVal SysAllocString(ByVal StrPtr(curFile.Name))
                    
                    If inIDE Then
                        DoEvents
                    End If
                    
                    GdipBitmapUnlockBits thumb, bd
                    
                End If

                GdipDisposeImage thumb

            End If

            GdipDisposeImage image

        End If

        fileIndex = fileIndex + 1

    Next
    
    PostMessage param.NotifyWnd, SET_PROGRESS, 100, ByVal 0&
    param.Progress = 1
    
End Function

Private Function MakeTrue(Value As Boolean) As Boolean
    MakeTrue = True: Value = True
End Function

